'*******************************************************************************
'             STEROWNIK SYNTEZY CZESTOTLIWOSCI Z UKLADEM TSA6057
'*******************************************************************************
'Autor :  Micha Wojtkw
'Data  :  4.01.2004
'e-mail:  michallo4@wp.pl
'www   :  www.michallo.ll.pl
'GG#   :  714371
'uwagi :  program ustepniony dla www.easy-soft.prv.pl
'*******************************************************************************
'                       KONFIGURACJA PODSTAWOWA
'*******************************************************************************
$crystal = 4190000                                          'deklaracja rezonatora
$regfile = "4433def.dat"                                    'wybr procesora
Config Lcd = 16 * 2
Config Lcdpin = Pin , Db4 = Portb.1 , Db5 = Portb.2 , Db6 = Portb.3 , Db7 = Portb.4 , E = Portb.0 , Rs = Portd.7
Cursor Off
Config Debounce = 30
Config Sda = Portc.5
Config Scl = Portc.4
Config Pinc.2 = Output
Config Pinc.1 = Output
Config Pinc.0 = Output
Config Pind.4 = Input
Config Pind.3 = Input
Config Pind.2 = Input
Config Pind.1 = Input
Config Pind.0 = Input
Dim Db0 As Byte
Dim Db1 As Byte
Dim Db2 As Byte
Dim A As Byte
Dim Key As Byte
Dim _eep(3) As Byte
Dim Frequency As Word
Dim Mnoznik As Byte
Dim Pokazanaf As Long
Dim Pokazanaff As String * 10
Dim Pokazanafstr As String * 10
Portc.0 = 1
Portc.1 = 1
Podswietlanie Alias Portc.2
Reset Podswietlanie
'*******************************************************************************
'                             poczatek programu
'*******************************************************************************
   Gosub Odczyt_ustawien

   Cls
   Locate 1 , 4
   Lcd "PLL-Driver"
   Locate 2 , 6
   Lcd "Welcome"
   Wait 2

   Cls
   Locate 1 , 3
   Lcd "Nie do konca"
   Locate 2 , 1
   Lcd "komercyjne radio"
   Wait 2
'*******************************************************************************
'                               Petla glowna
'*******************************************************************************
Petla_glowna:
   Cls
   Locate 1 , 3
   Pokazanaf = Frequency * Mnoznik
   Pokazanaff = Str(pokazanaf)
   Pokazanafstr = Format(pokazanaff , "00.0000")
   Pokazanaff = Format(pokazanafstr , "000.0")
   Lcd Pokazanaff : Lcd " MHz"
Podswitlanie_off:
   For A = 1 To 250
      Gosub Klawisz
         If Key = 1 Then : Gosub Menu : End If
         If Key = 2 Then : Toggle Portc.0 : End If
         If Pind.2 = 0 Then : Portc.1 = 0 : Else : Portc.1 = 1 : End If
         If Key = 4 Then : Goto Frequency : End If
      Waitms 20
   Next A
   Set Podswietlanie
      Do
         Gosub Klawisz
         If Key = 1 Then : Gosub Menu : End If
         If Key = 2 Then : Toggle Portc.0 : End If
         If Pind.2 = 0 Then : Portc.1 = 0 : Else : Portc.1 = 1 : End If
         If Key = 4 Then : Goto Frequency : End If
         If Key = 5 Then : Reset Podswietlanie : Goto Podswitlanie_off : End If
      Loop
'*******************************************************************************
'                        OBSLUGA KLAWIATURY
'*******************************************************************************
Klawisz:
   Key = 0
   Debounce Pind.4 , 0 , Przypisanie , Sub
   Debounce Pind.3 , 0 , Przypisanie , Sub
   Debounce Pind.2 , 0 , Przypisanie , Sub
   Debounce Pind.1 , 0 , Przypisanie , Sub
   Debounce Pind.0 , 0 , Przypisanie , Sub
Return

Przypisanie:
   If Pind.4 = 0 Then : Key = 1 : End If
   If Pind.3 = 0 Then : Key = 2 : End If
   If Pind.2 = 0 Then : Key = 3 : End If
   If Pind.1 = 0 Then : Key = 4 : End If
   If Pind.0 = 0 Then : Key = 5 : End If
Return
'*******************************************************************************
'                                 menu
'*******************************************************************************
Menu:
   Reset Podswietlanie
   Cls
   Locate 1 , 1
   Lcd "1-Setup   2-freq"
   Locate 2 , 5
   Lcd "3-format"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Goto Setup : End If
         If Key = 2 Then : Goto Frequency : End If
         If Key = 3 Then : Goto Formatt : End If
         If Key = 5 Then : Goto Petla_glowna : End If
      Loop
'*******************************************************************************
'                            setup
'*******************************************************************************
Setup:
   Cls
   Locate 1 , 1
   Lcd "1-krok 2-PradPLL"
   Locate 2 , 1
   Lcd "      3-BS"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Goto Krok : End If
         If Key = 2 Then : Goto Prad : End If
         If Key = 3 Then : Goto Bs : End If
         If Key = 5 Then : Goto Menu : End If
      Loop
'*******************************************************************************
'                            KROK
'*******************************************************************************
Krok:
   Cls
   Locate 1 , 1
   Lcd "Krok PLL: [kHz]"
   Locate 2 , 1
   Lcd "1-10  2-25"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Goto 10khz : End If
         If Key = 2 Then : Goto 25khz : End If
         If Key = 5 Then : Goto Setup : End If
      Loop
'*******************************************************************************
'                                 PRAD
'*******************************************************************************
Prad:
   Cls
   Locate 1 , 1
   Lcd "Prad            "
   Locate 2 , 1
   Lcd "1-5uA    2-500uA"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Goto Current1 : End If
         If Key = 2 Then : Goto Current2 : End If
         If Key = 5 Then : Goto Menu : End If
      Loop
'*******************************************************************************
'                         Band Switch Output
'*******************************************************************************
Bs:
   Cls
   Locate 1 , 1
   Lcd "Band Switch Out."
   Locate 2 , 1
   Lcd "1-Sink   2-Float"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Goto Sink : End If
         If Key = 2 Then : Goto Float : End If
         If Key = 5 Then : Goto Menu : End If
      Loop
'*******************************************************************************
'                                  10khz
'*******************************************************************************
10khz:
   Db2.6 = 1
   Db2.7 = 0
   Mnoznik = 100
   Frequency = 9200
   Gosub Konwersja
   Goto Krok
'*******************************************************************************
'                                  12Khz
'*******************************************************************************
25khz:
   Db2.6 = 0
   Db2.7 = 1
   Mnoznik = 250
   Frequency = 3680
   Gosub Konwersja
   Goto Krok
'*******************************************************************************
'                                 Current1:
'*******************************************************************************
Current1:
   Db0.0 = 0
   Gosub Konwersja
   Goto Setup
'*******************************************************************************
'                                 Current2:
'*******************************************************************************
Current2:
   Db0.0 = 1
   Gosub Konwersja
   Goto Setup
'*******************************************************************************
'                               Sink Current:
'*******************************************************************************
Sink:
   Db2.2 = 1
   Gosub Konwersja
   Goto Setup
'*******************************************************************************
'                                 Floating:
'*******************************************************************************
Float:
   Db2.2 = 0
   Gosub Konwersja
   Goto Setup
'*******************************************************************************
'                                 frequency
'*******************************************************************************
Frequency:
   Reset Podswietlanie
   Cls
   Locate 1 , 3
   Pokazanaf = Frequency * Mnoznik
   Pokazanaff = Str(pokazanaf)                              'Frequency * Mnoznik
   Pokazanafstr = Format(pokazanaff , "00.0000")
   Pokazanaff = Format(pokazanafstr , "000.0")
   Lcd Pokazanaff : Lcd " MHz"
   Locate 2 , 1
   Lcd "1-UP FREQ DOWN-2"
   Waitms 500
      Do
         Gosub Klawisz
         If Key = 1 Then : Gosub Up : End If
         If Key = 2 Then : Gosub Down : End If
         If Key = 3 Then : Gosub Konwersja : End If
         If Key = 4 Then : Goto Petla_glowna : End If
         If Key = 5 Then : Gosub Konwersja : Goto Menu : End If
      Loop
'*******************************************************************************
'                                  UP
'                       Zmiana czstotliwoci w gr
'*******************************************************************************
Up:
   Frequency = Frequency + 1
   Pokazanaf = Frequency * Mnoznik
   Pokazanaff = Str(pokazanaf)                              'Frequency * Mnoznik
   Pokazanafstr = Format(pokazanaff , "00.0000")
   Pokazanaff = Format(pokazanafstr , "000.0")
   Locate 1 , 1
   Lcd "                "
   Locate 1 , 3
   Lcd Pokazanaff : Lcd " MHz"
Return
'*******************************************************************************
'                                  down
'                       Zmiana czstotliwoci w d
'*******************************************************************************
Down:
   Frequency = Frequency - 1
   Pokazanaf = Frequency * Mnoznik
   Pokazanaff = Str(pokazanaf)                              'Frequency * Mnoznik
   Pokazanafstr = Format(pokazanaff , "00.0000")
   Pokazanaff = Format(pokazanafstr , "000.0")
   Locate 1 , 1
   Lcd "                "
   Locate 1 , 3
   Lcd Pokazanaff : Lcd " MHz"
Return
'*******************************************************************************
'                                  format
'              Ustawienie domylnej konfiguracji i czstotliwoci
'*******************************************************************************
Formatt:
   Frequency = 9070
   Db2.6 = 1
   Db2.7 = 0
   Db0.0 = 0
   Db2.2 = 0
   Gosub Konwersja
   Gosub Odczyt_ustawien
   Goto Petla_glowna
'*******************************************************************************
'                 odczyt ustawien z eeprom i wysanie do TSA6057
'*******************************************************************************
Odczyt_ustawien:
      For A = 1 To 3
         Readeeprom _eep(a) , A
         Waitms 50
      Next A
   Gosub Konwersja1
   Gosub Tsa
      If _eep(3).7 = 0 Then : Mnoznik = 100 : Else : Mnoznik = 250 : End If
Return
'*******************************************************************************
'                                 TSA 6057
'            Wysanie danych do ukadu TSA6057 przez magistrale i2c
' UWAGA: jesli blednie podlaczymy ukad lub zle ustawimy adres
'                    pojawi sie napis "brak TSA6057"
'*******************************************************************************
Tsa:
   I2cstart
   I2cwbyte 196
   I2cwbyte 0
   I2cwbyte Db0
   I2cwbyte Db1
   I2cwbyte Db2
   I2cwbyte 0
   I2cstop
      If Err = 1 Then : Cls : Locate 1 , 2 : Lcd "Brak TSA6057" : Wait 1 : End If
Return
'*******************************************************************************
'                              Konwersja danych
'              Podstawia dane w celu zapisania ich w eeprom
'*******************************************************************************
Konwersja:
   'Db0.0 = Prad
   Db0.1 = Frequency.0
   Db0.2 = Frequency.1
   Db0.3 = Frequency.2
   Db0.4 = Frequency.3
   Db0.5 = Frequency.4
   Db0.6 = Frequency.5
   Db0.7 = Frequency.6
   '********************
   Db1.0 = Frequency.7
   Db1.1 = Frequency.8
   Db1.2 = Frequency.9
   Db1.3 = Frequency.10
   Db1.4 = Frequency.11
   Db1.5 = Frequency.12
   Db1.6 = Frequency.13
   Db1.7 = Frequency.14
   '********************
   Db2.0 = Frequency.15
   Db2.1 = 0
   'Db2.2 = BS
   Db2.3 = 0
   Db2.4 = 0
   Db2.5 = 1
   'Db2.6 = krok
   'Db2.7 = krok
   '********************
   _eep(1) = Db0
   _eep(2) = Db1
   _eep(3) = Db2
      For A = 1 To 3
         Writeeeprom _eep(a) , A
         Waitms 50
      Next A
   Gosub Tsa
Return


'*******************************************************************************
'                                 Konwersja1
'                 Podstawia dane po doczytaniu ich z eeprom
'*******************************************************************************
Konwersja1:
   Db0 = _eep(1)
   Db1 = _eep(2)
   Db2 = _eep(3)
   Frequency.0 = _eep(1).1
   Frequency.1 = _eep(1).2
   Frequency.2 = _eep(1).3
   Frequency.3 = _eep(1).4
   Frequency.4 = _eep(1).5
   Frequency.5 = _eep(1).6
   Frequency.6 = _eep(1).7
   Frequency.7 = _eep(2).0
   Frequency.8 = _eep(2).1
   Frequency.9 = _eep(2).2
   Frequency.10 = _eep(2).3
   Frequency.11 = _eep(2).4
   Frequency.12 = _eep(2).5
   Frequency.13 = _eep(2).6
   Frequency.14 = _eep(2).7
   Frequency.15 = _eep(3).0
Return

'*******************************************************************************
'                                 The End
'*******************************************************************************